# coding: utf-8

"""
    Mtmai API

    The Mtmai API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from mtmaisdk.clients.rest.models.event_base import EventBase
from mtmaisdk.clients.rest.models.event_new_agent_state import EventNewAgentState
from mtmaisdk.clients.rest.models.event_types import EventTypes
from mtmaisdk.clients.rest.models.start_workflow_run_event import StartWorkflowRunEvent
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

AGEVENTV2_ONE_OF_SCHEMAS = ["EventBase", "EventNewAgentState", "EventTypes", "StartWorkflowRunEvent"]

class AgEventV2(BaseModel):
    """
    AgEventV2
    """
    # data type: EventNewAgentState
    oneof_schema_1_validator: Optional[EventNewAgentState] = None
    # data type: EventTypes
    oneof_schema_2_validator: Optional[EventTypes] = None
    # data type: EventBase
    oneof_schema_3_validator: Optional[EventBase] = None
    # data type: StartWorkflowRunEvent
    oneof_schema_4_validator: Optional[StartWorkflowRunEvent] = None
    actual_instance: Optional[Union[EventBase, EventNewAgentState, EventTypes, StartWorkflowRunEvent]] = None
    one_of_schemas: Set[str] = { "EventBase", "EventNewAgentState", "EventTypes", "StartWorkflowRunEvent" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = AgEventV2.model_construct()
        error_messages = []
        match = 0
        # validate data type: EventNewAgentState
        if not isinstance(v, EventNewAgentState):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EventNewAgentState`")
        else:
            match += 1
        # validate data type: EventTypes
        if not isinstance(v, EventTypes):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EventTypes`")
        else:
            match += 1
        # validate data type: EventBase
        if not isinstance(v, EventBase):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EventBase`")
        else:
            match += 1
        # validate data type: StartWorkflowRunEvent
        if not isinstance(v, StartWorkflowRunEvent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `StartWorkflowRunEvent`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in AgEventV2 with oneOf schemas: EventBase, EventNewAgentState, EventTypes, StartWorkflowRunEvent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in AgEventV2 with oneOf schemas: EventBase, EventNewAgentState, EventTypes, StartWorkflowRunEvent. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into EventNewAgentState
        try:
            instance.actual_instance = EventNewAgentState.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EventTypes
        try:
            instance.actual_instance = EventTypes.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EventBase
        try:
            instance.actual_instance = EventBase.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into StartWorkflowRunEvent
        try:
            instance.actual_instance = StartWorkflowRunEvent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into AgEventV2 with oneOf schemas: EventBase, EventNewAgentState, EventTypes, StartWorkflowRunEvent. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into AgEventV2 with oneOf schemas: EventBase, EventNewAgentState, EventTypes, StartWorkflowRunEvent. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], EventBase, EventNewAgentState, EventTypes, StartWorkflowRunEvent]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


